# frozen_string_literal: true

require 'kenny_speak/version'
require 'kenny_speak/letters'
require 'kenny_speak/overloads'

#
# To Follow
#
module KennySpeak
    #
    # To Follow
    #
    class Kenny
        def self.to_kenny(str)
            result = ''

            str.split('').each do |c|
                result += if c =~ /[[:alpha:]]/
                              kenny_from_letter(c)
                          else
                              c
                          end
            end
            result
        end

        def self.from_kenny(str)
            result = ''

            str.gsub(/\s+/m, ' ').strip.split(' ').each do |word|
                word.scan(/.{1,3}/).each do |tuple|
                    result += letter_from_kenny(tuple)
                end
                result += ' '
            end
            result.rstrip
        end

        def self.kenny_from_letter(letter)
            upper = false

            upper = true if letter =~ /[[:upper:]]/

            tmp = letter.downcase

            offset = tmp.ord - 97

            tuple = KENNY_LETTERS[offset]

            return tuple.capitalize if upper

            tuple
        end

        def self.letter_from_kenny(tuple)
            return tuple if tuple.length != 3                # Not a tuple
            return tuple if tuple[/[a-zA-Z0-9]+/] != tuple   # Not just letters

            upper = false

            upper = true if tuple.chr =~ /[[:upper:]]/

            tmp = tuple.downcase

            offset = KENNY_LETTERS.index(tmp)

            return tuple if offset.nil?

            letter = (offset.to_i + 97).chr

            return letter.upcase if upper

            letter
        end
    end
end
